
#include "MiniGame.h"
#include "CChip.h"




extern CChip *GetMyChip();
extern CChip *GetBallChip();


// ------------------------------------------------------------------
// CChip o֐   LN^[̊NX
// ------------------------------------------------------------------

CChip::CChip() //pNXɂׂĂʉ߂
{
	x = 0.0f;
	y = 0.0f;
	dx = 0.0f;
	dy = 0.0f;
	No = 0;
	iLive = 0;
	count = 0;
}

CChip::~CChip() //pNXɂׂĂʉ߂
{

}

int CChip::Put()
{
	return PutChip( x , y, GetNo() );
}

// ------------------------------------------------------------------
// CRadish o֐ Jup
// ------------------------------------------------------------------
CRadish::CRadish()
{
	x = (CHIP_SIZE*5) + GetRand( SCREEN_WIDTH-(CHIP_SIZE*10) );
	y = MAP_BOTTOM - CHIP_SIZE + 0.1f*16;
	dx = 0.0f;
	dy = 0.0f;
	No = CHIP_RADISH * 10;
	iLive = 1;
	count = 0;
	iMode = 0;// [hp 0:o 1:k 2:A
}

CRadish::~CRadish()
{

}

int CRadish::Move()
{
	CPlayer *cp = NULL;
	switch( iMode ){
		case 0:
			y = y - 0.1f;
			x = x + ( (float)GetRand(10)-5.0f ) / 10.0f;
			if( count > 16 ){
				iMode = 1;
				count = 0;
			}
			break;
		case 1:
			if( count > 500 ){
				iMode = 2;
				count = 0;
			}
			cp = (CPlayer*)GetMyChip();
			if( cp && !cp->GetOuchFlag() ){
				if( abs( cp->GetX() - x )<16 && abs( cp->GetY() - (y+(CHIP_SIZE/2)) ) < 16 ){
					PlaySoundMem( hVoice3 , DX_PLAYTYPE_BACK );
					cp->OuchDown(); // vC[]
					iMode = 2;
					count = 0;
				}
			}
			break;
		case 2:
			y = y + 0.1f;
			x = x + ( (float)GetRand(10)-5.0f ) / 10.0f;
			
			if( count > 16 ){
				iLive = 0;
			}
			
			break;
	}
	count++;
	return 0;
}


// ------------------------------------------------------------------
// CCrow o֐ JXp
// ------------------------------------------------------------------
CCrow::CCrow()
{
	// JXʒȕ
	x = 0;
	y = (4 + GetRand( 3 )) * CHIP_SIZE;
	No = CHIP_CROW_R * 10;
	iLive = 1;
	
	dx = (SPEED/3.0);
	dy = 1.0f;
	ddy = 0.1f;
	count = 0;

	PlaySoundMem( hVoice2 , DX_PLAYTYPE_BACK );
	total_count = 0;
}


CCrow::~CCrow()
{
}

int CCrow::Move()
{
	//[[܂ňړ
	x = x + dx;
	if( x > SCREEN_WIDTH ){
		iLive = 0;
	}
	
	// ㉺ɂƂ鏈
	if( dy > 1.0f ){ ddy = 0.0f - ddy; dy = 1.0f;}
	else if( dy < -1.0f ){ ddy = 0.0f - ddy; dy = -1.0f;}
	y = y + dy;
	dy = dy + ddy;
	
	
	//{[Ƃ̓蔻
	CBall *cB = (CBall*)GetBallChip();
	if( cB ){
		if( abs( x-cB->GetX() ) < CHIP_SIZE && abs( y-cB->GetY() ) < CHIP_SIZE ){
			cB->JumpUp();
			if( CheckSoundMem( hVoice2 ) == 0 ){
				PlaySoundMem( hVoice2 , DX_PLAYTYPE_BACK );
			}
		}
	}
	
	//Aj[V
	count = (count + 1) % 20;
	No = CHIP_CROW_R * 10 + count;

	// xڂ́uJAv
	if(total_count == 20 ){
		PlaySoundMem( hVoice2 , DX_PLAYTYPE_BACK );
	}
	total_count++;

	return 0;
}


// ------------------------------------------------------------------
// CCloudEffect o֐  _\p
// ------------------------------------------------------------------
CCloudEffect::CCloudEffect()
{
	// _̈ʒu
	x = (SCREEN_WIDTH-CHIP_SIZE);
	y = GetRand( 3 ) * CHIP_SIZE;
	No = CHIP_CLOUD * 10;
	iLive = 1;
	dx = ( (y/CHIP_SIZE)/5.0 ) +0.1;
}

CCloudEffect::~CCloudEffect()
{
}


int CCloudEffect::Move(){
	x = x - dx;
	if( x < (0.0f-CHIP_SIZE) ){
		iLive = 0;
	}
	return 0;
}


int CCloudEffect::Put(){

	return PutChip2( x , y, GetNo() );
}


// ------------------------------------------------------------------
// CSun o֐  z\p
// ------------------------------------------------------------------
CSun::CSun()
{
	// ʒu
	x = (CHIP_SIZE);
	y = 5.0f;
	No = CHIP_SUN * 10;
	iLive = 1;
	dx = 0.01f;
}

CSun::~CSun()
{
}


int CSun::Move(){
	x = x + dx;
	if( x > (SCREEN_WIDTH) ){
		iLive = 0;
	}
	return 0;
}


// ------------------------------------------------------------------
// NX CActEffect   l̓GtFNgp
// ------------------------------------------------------------------
CActEffect::CActEffect( int iType ){
	x = GetMyChip()->GetX();
	y = GetMyChip()->GetY();

	iLive = 1;
	count = 0;
	
	dx = 0.0f - GetMyChip()->GetDX();
	dx = dx / 2.0f;
	if( dx < 0.0f ){
		No = CHIP_WET_L * 10;
	}else{
		No = CHIP_WET_R *10;
	}
	
	dy = 0.2f;
}
CActEffect::~CActEffect(){
}

int CActEffect::Move(){
	
	x = x + dx;
	y = y + dy;
	
	count++;
	if( count > 10 ){
		iLive = 0;
	}
	
	return 0;
}



// ------------------------------------------------------------------
// CScoreEffect o֐  XRAʂ̗p(+1\Miss\)
// ------------------------------------------------------------------

// _\pCHIP
CScoreEffect::CScoreEffect( int type )
{
	iType = type;
	iLive = 1;
	
	if( iType == 1 ){
		No = CHIP_PLUSE * 10;
		x = GetBallChip()->GetX();
		y = GetBallChip()->GetY() + (CHIP_SIZE/2.0f);
	}else{
		No = CHIP_MISS * 10;
		x = GetBallChip()->GetX();
		y = GetBallChip()->GetY();
	}
}

CScoreEffect::~CScoreEffect(){
}





// _\̓
int CScoreEffect::Move()
{
	float MoveX = 0.0f, MoveY = 0.0f;

	if( iLive ){
		// ScoreUp
		if( iType == 1 ){
			MoveY = 0.0 -1.0f;
			iLive++;
			if( iLive > 20 )
				iLive = 0;
		}
		// Miss
		if( iType == 2 ){
			MoveY = 0.0 -0.5f;
			iLive++;
			if( iLive > 20 )
				iLive = 0;
		}
		
		x += MoveX;
		y += MoveY;
	}

	return 0;
}




// ------------------------------------------------------------------
// CBall o֐  {[p
// ------------------------------------------------------------------

// {[̕ϐ
CBall::CBall(){
	x = 100.0f;
	y = (float)(MAP_BOTTOM-CHIP_SIZE);
	fJump = TRUE;
	lJ = 0.0f - BJUMP;
	No = CHIP_EGG * 10;// LN^ԍ*10
	JMoveX = 0.0f;

	iLive = 1;

	fScoreFail = FALSE;
}

CBall::~CBall(){
}

// {[̓
int CBall::Move()
{
    // ړʂ̏
    dx = JMoveX;
    dy = 0.0f;
	No = CHIP_EGG*10;
	
	if( fJump ){
		dy = lJ;
		lJ += 0.2f;
		if( lJ > BJUMP ){ lJ = BJUMP;}
	}
	CPlayer *cP = (CPlayer*)GetMyChip();
	
	//vC[Ƃ̂蔻
	if( abs( x - cP->GetX() ) < CHIP_SIZE && abs( y - cP->GetY() ) < CHIP_SIZE ){
		// ڐGAvC[̓Wv㏸
		if( cP->GetJumpOffset() < 0.0f ){
			No = CHIP_EGG2 *10;
			// {[͂ɃWv
			fJump = TRUE; lJ = 0.0f - BJUMP;
			// vC[̐{[ɓ`
			JMoveX += (cP->GetJumpX() /2.0f);
			// ̏Wv͉ivp^[ɂȂ̂
			if( !JMoveX ){
				JMoveX = (cP->GetX() < x )? SPEED : 0.0f - SPEED;
			}
			dx = JMoveX;
			
			cP->JumpDown();
			
			// _\
			score++;
			SetScoreUp();
			fScoreFail = FALSE;
			
		}
		// ڐG͒nゾ
		else if( !cP->GetJumpFlag() ){
			No = CHIP_EGG2 * 10;
			// {[͂ƃWv
			fJump = TRUE; lJ = 0.0f - (BJUMP/2.0f);
			// vC[̐{[ɓ`
			//JMoveX = (stP.No>15)? SPEED : 0.0f - SPEED;
			JMoveX = (cP->GetX() < x )? SPEED : 0.0f - SPEED;
			dx = JMoveX;
			
			// vC[荂ʒuɂȂ΁d
			if( y < cP->GetY() ){
				fScoreFail = FALSE;
			}
		}
	}




	// E͂ݏo
	if( (x+dx) < 0 || (x+dx) > (SCREEN_WIDTH-CHIP_SIZE) ){
		dx = 0.0f;
		float rad = ( (float)GetRand( 10 ) ) / 10.0f;
		JMoveX = 0.0f - (JMoveX*rad);
		
		if( y <= (MAP_BOTTOM-CHIP_SIZE) ){
			// _\
			score++;
			SetScoreUp();
			fScoreFail = FALSE;
		}
	}
	// nʂ͂ݏo
	if( (y+dy) >= (MAP_BOTTOM-CHIP_SIZE) ){
		// W͒nʂɂ
		dy = 0.0f;
		y = (MAP_BOTTOM-CHIP_SIZE);
		// 
		JMoveX = 0.0f;
		// ~X\
		if( !fScoreFail ){
			fScoreFail = TRUE;
			SetScoreFail();
		}
		score = 0;
	}

	x += dx;
	y += dy;


	return 0;
}

// OLWv̉~w
void CBall::JumpDown()
{
	// ڐGAWv㏸
	if( lJ < 0.0f ){
		// Wv~
		lJ = 0.0f - lJ;
	}

}

// OLăWvw
void CBall::JumpUp()
{

	// {[͂ƃWv
	fJump = TRUE; lJ = 0.0f - (BJUMP/2.0f);
//	JMoveX = (cP->GetX() < x )? SPEED : 0.0f - SPEED;
	JMoveX = 0.0f - JMoveX;
//	dx = JMoveX;

	// _\
	score++;
	SetScoreUp();
	fScoreFail = FALSE;


}



// ------------------------------------------------------------------
// CPlayer o֐  vC[p
// ------------------------------------------------------------------
CPlayer::CPlayer(){


	// l̕ϐ
	x = 60.0f;
	y = (float)(MAP_BOTTOM-CHIP_SIZE);
	fJump = FALSE;
	fOuch = FALSE;
	fStall = FALSE;
	No = CHIP_MY_F * 10; // LN^ԍ*10
	JMoveX = 0.0f; // WvX̑
	
	iLive = 1;

}

CPlayer::~CPlayer(){

}


// vC[̓
int CPlayer::Move()
{

	// ړʂ̏
	dx = 0.0f;
    dy = 0.0f;

	if( fOuch ){
        MoveOuch();
	}else{
    
     // ʏړ[h
		// Ëړ
	    if( ( Input & PAD_INPUT_LEFT ) != 0 ){ dx -= SPEED ;		 No = CHIP_MY_L*10 + (No + 5) % 30; }
	    else if( ( Input & PAD_INPUT_RIGHT ) != 0 ){ dx += SPEED ;	 No = CHIP_MY_R*10 + (No + 5) % 30; }
		else{ No = CHIP_MY_F*10; count = 0; }
	
		// 肷Ɗ
		if( dx != 0.0f && (count % 50) == 49 ){
			WakeupWet();
		}
		
		
	    // nɑĂꍇ̂݃Wv{^({^P or yL[)
	    if( ( fJump == FALSE && EdgeInput & PAD_INPUT_A ) != 0 ){
			fJump = TRUE; lJ = 0.0f - PJUMP; JMoveX = dx;
			PlaySoundMem( hVoice1 , DX_PLAYTYPE_BACK );
		}
		
		// Wv̏
		if( fJump ){
			dy = lJ;
			dx = JMoveX;
			lJ += 0.2f;
			No = (JMoveX > 0)? CHIP_MY_JUMPR*10 : CHIP_MY_JUMPL*10;
			if( lJ > PJUMP ) lJ = PJUMP;
		}
	
	}
	
	count++;
	
	// E͂ݏo
	if( (x+dx) < 0 || (x+dx) > (SCREEN_WIDTH-CHIP_SIZE) ){
		dx = 0.0f;
	}
	
	// nʂ͂ݏo
	if( y+dy > (MAP_BOTTOM-CHIP_SIZE) ){
		dy = 0.0f;
		fJump = FALSE;
		y = (MAP_BOTTOM-CHIP_SIZE);
		if( fOuch ){ // ]ђ؃[hJn
			fStall = TRUE;
			count = 0;
		}
	}
	
	x = x + dx;
	y = y + dy;
	


	return 0;
}

// ]я
int CPlayer::MoveOuch()
{
	// ]ђ
	if( !fStall ){
		dy = lJ;
		dx = JMoveX;
		lJ += 0.3f;
		if( lJ > PJUMP ) lJ = PJUMP;
	}else{
		// ]яI҂
		dx = JMoveX;
		JMoveX = JMoveX * 0.9f;
		if( count > 100 ){
			fStall = FALSE;
			fOuch = FALSE;
		}
	}
	No = (JMoveX > 0)? CHIP_MY_OUCHR*10 : CHIP_MY_OUCHL*10;
    return 0;
}

// OLWv̉~w
void CPlayer::JumpDown()
{
	// ڐGAvC[̓Wv㏸
	if( lJ < 0.0f ){
		// vC[̓Wv~
		lJ = 0.0f - lJ;
	}

}

// OL炱Ԃw
void CPlayer::OuchDown()
{
	fOuch = TRUE; lJ = (0.0f - PJUMP) ;
	JMoveX = dx/2.0f;
	if( !JMoveX ){
		JMoveX = SPEED/2.0f;
	}
}

