#ifndef _MINIGAME_H_
#define _MINIGAME_H_

#include <stdio.h>
#include "DxLib.h"

#define SCREEN_WIDTH     (640/2)                          // ʂ̉
#define SCREEN_HEIGHT    (480/2)                          // ʂ̏c
#define CHIP_SIZE        (16)                           // ̃`bṽTCY
#define MAP_BOTTOM		(SCREEN_HEIGHT - CHIP_SIZE*4)	// }bv̒nドC

#define MAP_WIDTH        (SCREEN_WIDTH / CHIP_SIZE)     // }bv̉
#define MAP_HEIGHT       (SCREEN_HEIGHT / CHIP_SIZE)    // }bv̏c

#define SPEED            (2.0F)                         // L̈ړXs[h
#define PJUMP           (4.0F)                         // L̈ړXs[h
#define BJUMP           (6.0F)                         // L̈ړXs[h

// CHIPp^[̔ԍ
#define CHIP_RADISH		(38)
#define CHIP_CROW_L		(9)
#define CHIP_CROW_R		(15+9)
#define CHIP_CLOUD		(36)
#define CHIP_SUN		(37)
#define CHIP_PLUSE		(39)
#define CHIP_MISS		(41)
#define CHIP_WET_L		(7)
#define CHIP_WET_R		(15+7)
#define CHIP_EGG		(5)
#define CHIP_EGG2		(15+5)

#define CHIP_MY_F		(34)
#define CHIP_MY_L		(0)
					// CHIP_MY_L  0,1,2
#define CHIP_MY_R		(15)
					// CHIP_MY_L  15+ (0,1,2)
#define CHIP_MY_JUMPL	(3)
#define CHIP_MY_JUMPR	(15+3)
#define CHIP_MY_OUCHL	(8)
#define CHIP_MY_OUCHR	(15+8)

#define CHIP_SKY		(32)
#define CHIP_GROUND		(31)


extern int Input, EdgeInput;
extern int score;
extern int hi_score;
extern int hVoice1;
extern int hVoice2;
extern int hVoice3;

extern int SetScoreUp();
extern int SetScoreFail();
extern int PutChip( float x , float y , int no );
extern int PutChip2( float x , float y , int no );
extern int WakeupWet();


#endif


